#include "const.h"



#ifndef _CHANNEL_H_
#define _CHANNEL_H_

class CHANNEL
{
public:

	void Set_channel(double, bool, int, int, LOCATION, LOCATION);
	void Update(double, int);
	void Precalculate(int);
	//void Kill_precalculate(void);
	void Load_precalculate(double, int, int);
	double LOS_prob;
	double pathloss;
	double pathloss_2;
	LOCATION self_bs;
	LOCATION self_ms;
	bool LOS;
	bool Indoor;
	double RMS_delay_spread;
	double circular_angle_spread_AOA;
	double circular_angle_spread_AOD;

	int self_bs_idx;
	int self_ms_idx;
	LOCATION bs_location;
	LOCATION ms_location;

	double* delay;
	double* delay_LOS;

	double* power;
	double* power_LOS;
	double* power_NLOS;


	double* AOA;
	double* AOD;
	double* ZOA;
	double* ZOD;

	double* AOA_LOS;
	double* AOD_LOS;
	double* ZOA_LOS;
	double* ZOD_LOS;

	double* AOA_NLOS;
	double* AOD_NLOS;
	double* ZOA_NLOS;
	double* ZOD_NLOS;
	
	double* delay_power;
	double* RMS_delay_power;
	double* power_ray_sum;
	double* power_ray_sum_circular;
	double* AOA_power;
	double* AOD_power;
	double* theta_n_m_mu_AOA;
	double* theta_n_m_mu_AOD;
	double* theta_power_AOA;
	double* theta_power_AOD;

	double strongest_power;
	double strongest_power2;
	int strongest_power_idx;
	int strongest_power_idx2;

	double** random_phase_vv;
	double** random_phase_vh;
	double** random_phase_hv;
	double** random_phase_hh;
	double random_phase_vv_LOS;
	double random_phase_hh_LOS;

	double F_tx_v;
	double F_tx_h;
	double F_rx_v;
	double F_rx_h;

	double F_vv;
	double F_vh;
	double F_hv;
	double F_hh;

	double d_rx;
	double d_tx;

	//int	bs_idx;
	int ms_idx;

	complex <double> *** CHIR;
	//complex <double> ******* CHIR_precalculate;

	double ** offset_angle;

	//parameter
	int num_ray;
	int num_path;
	double distance;


	double D;
	double r_tau;
	double K_factor;
	double sigma_tau;
	double mu_K_factor;
	double sigma_K_factor;
	double mu_DS;
	double sigma_DS;
	double mu_ASD;
	double sigma_ASD;
	double mu_ASA;
	double sigma_ASA;
	double mu_ZSA;
	double sigma_ZSA;
	double mu_ZSD;
	double sigma_ZSD;

	double mu_offset_ZOD;

	double cluster_ASD;
	double cluster_ASA;
	double cluster_ZSA;
	double XPR;
	double cluster_shadowing;
	double sigma_SF;
	//double d_rx;
	//double d_tx;

	
	double correlated_randnum_SF;
	double correlated_randnum_DS;
	double correlated_randnum_ASD;
	double correlated_randnum_ASA;
	double correlated_randnum_K;

	void Set_LOS_Prob();
	void Set_PATHLOSS();
	void Set_SHADOWFADING();
	void Set_Channel_Parameters();

	void Set_DELAY();
	void Set_POWER();
	void Find_Strong2Clusters();
	void Set_AOAAOD();
	void Set_ZOAZOD();
	void Set_InitialPhase();
	void Set_SUBCLUSTER();
	void Set_RMS_delay_spread();
	void Set_circular_angle_spread();

	void Set_AOAAOD_LOS();
	void Set_AOAAOD_NLOS();

	void Set_ZOAZOD_LOS();
	void Set_ZOAZOD_NLOS();

	void Kill_Memory();

private:
	



};

#endif